//
//     Copyright 2022 The Dragonfly Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by protoc-gen-go. DO NOT EDIT.
// versions:
// 	protoc-gen-go v1.28.0
// 	protoc        v3.19.4
// source: pkg/apis/errordetails/v2/errordetails.proto

package v2

import (
	v2 "d7y.io/api/pkg/apis/common/v2"
	_ "github.com/envoyproxy/protoc-gen-validate/validate"
	protoreflect "google.golang.org/protobuf/reflect/protoreflect"
	protoimpl "google.golang.org/protobuf/runtime/protoimpl"
	reflect "reflect"
	sync "sync"
)

const (
	// Verify that this generated code is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(20 - protoimpl.MinVersion)
	// Verify that runtime/protoimpl is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(protoimpl.MaxVersion - 20)
)

// PeerDownloadBackToSourceFailed is error detail of downloading back-to-source.
type PeerDownloadBackToSourceFailed struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// Temporary recoverable error of source.
	Temporary bool `protobuf:"varint,1,opt,name=temporary,proto3" json:"temporary,omitempty"`
	// Source response metadata, eg: HTTP Status Code, HTTP Status, HTTP Header
	Metadata *v2.ExtendAttribute `protobuf:"bytes,2,opt,name=metadata,proto3" json:"metadata,omitempty"`
	// The description of the error.
	Description string `protobuf:"bytes,3,opt,name=description,proto3" json:"description,omitempty"`
}

func (x *PeerDownloadBackToSourceFailed) Reset() {
	*x = PeerDownloadBackToSourceFailed{}
	if protoimpl.UnsafeEnabled {
		mi := &file_pkg_apis_errordetails_v2_errordetails_proto_msgTypes[0]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *PeerDownloadBackToSourceFailed) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*PeerDownloadBackToSourceFailed) ProtoMessage() {}

func (x *PeerDownloadBackToSourceFailed) ProtoReflect() protoreflect.Message {
	mi := &file_pkg_apis_errordetails_v2_errordetails_proto_msgTypes[0]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use PeerDownloadBackToSourceFailed.ProtoReflect.Descriptor instead.
func (*PeerDownloadBackToSourceFailed) Descriptor() ([]byte, []int) {
	return file_pkg_apis_errordetails_v2_errordetails_proto_rawDescGZIP(), []int{0}
}

func (x *PeerDownloadBackToSourceFailed) GetTemporary() bool {
	if x != nil {
		return x.Temporary
	}
	return false
}

func (x *PeerDownloadBackToSourceFailed) GetMetadata() *v2.ExtendAttribute {
	if x != nil {
		return x.Metadata
	}
	return nil
}

func (x *PeerDownloadBackToSourceFailed) GetDescription() string {
	if x != nil {
		return x.Description
	}
	return ""
}

// PieceDownloadFailed is error detail of downloading piece.
type PieceDownloadFailed struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// Temporary recoverable error of parent peer.
	Temporary bool `protobuf:"varint,1,opt,name=temporary,proto3" json:"temporary,omitempty"`
	// Parent peer id.
	ParentId string `protobuf:"bytes,2,opt,name=parent_id,json=parentId,proto3" json:"parent_id,omitempty"`
	// The description of the error.
	Description string `protobuf:"bytes,3,opt,name=description,proto3" json:"description,omitempty"`
}

func (x *PieceDownloadFailed) Reset() {
	*x = PieceDownloadFailed{}
	if protoimpl.UnsafeEnabled {
		mi := &file_pkg_apis_errordetails_v2_errordetails_proto_msgTypes[1]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *PieceDownloadFailed) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*PieceDownloadFailed) ProtoMessage() {}

func (x *PieceDownloadFailed) ProtoReflect() protoreflect.Message {
	mi := &file_pkg_apis_errordetails_v2_errordetails_proto_msgTypes[1]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use PieceDownloadFailed.ProtoReflect.Descriptor instead.
func (*PieceDownloadFailed) Descriptor() ([]byte, []int) {
	return file_pkg_apis_errordetails_v2_errordetails_proto_rawDescGZIP(), []int{1}
}

func (x *PieceDownloadFailed) GetTemporary() bool {
	if x != nil {
		return x.Temporary
	}
	return false
}

func (x *PieceDownloadFailed) GetParentId() string {
	if x != nil {
		return x.ParentId
	}
	return ""
}

func (x *PieceDownloadFailed) GetDescription() string {
	if x != nil {
		return x.Description
	}
	return ""
}

// PieceInfoSyncFailed is error detail of syncing piece info.
type PieceInfoSyncFailed struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// Temporary recoverable error of parent peer.
	Temporary bool `protobuf:"varint,1,opt,name=temporary,proto3" json:"temporary,omitempty"`
	// Parent peer id.
	ParentId string `protobuf:"bytes,2,opt,name=parent_id,json=parentId,proto3" json:"parent_id,omitempty"`
	// The description of the error.
	Description string `protobuf:"bytes,3,opt,name=description,proto3" json:"description,omitempty"`
}

func (x *PieceInfoSyncFailed) Reset() {
	*x = PieceInfoSyncFailed{}
	if protoimpl.UnsafeEnabled {
		mi := &file_pkg_apis_errordetails_v2_errordetails_proto_msgTypes[2]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *PieceInfoSyncFailed) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*PieceInfoSyncFailed) ProtoMessage() {}

func (x *PieceInfoSyncFailed) ProtoReflect() protoreflect.Message {
	mi := &file_pkg_apis_errordetails_v2_errordetails_proto_msgTypes[2]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use PieceInfoSyncFailed.ProtoReflect.Descriptor instead.
func (*PieceInfoSyncFailed) Descriptor() ([]byte, []int) {
	return file_pkg_apis_errordetails_v2_errordetails_proto_rawDescGZIP(), []int{2}
}

func (x *PieceInfoSyncFailed) GetTemporary() bool {
	if x != nil {
		return x.Temporary
	}
	return false
}

func (x *PieceInfoSyncFailed) GetParentId() string {
	if x != nil {
		return x.ParentId
	}
	return ""
}

func (x *PieceInfoSyncFailed) GetDescription() string {
	if x != nil {
		return x.Description
	}
	return ""
}

// ScheduleFailed is error detail of scheduling.
type ScheduleFailed struct {
	state         protoimpl.MessageState
	sizeCache     protoimpl.SizeCache
	unknownFields protoimpl.UnknownFields

	// The description of the error.
	Description string `protobuf:"bytes,1,opt,name=description,proto3" json:"description,omitempty"`
}

func (x *ScheduleFailed) Reset() {
	*x = ScheduleFailed{}
	if protoimpl.UnsafeEnabled {
		mi := &file_pkg_apis_errordetails_v2_errordetails_proto_msgTypes[3]
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		ms.StoreMessageInfo(mi)
	}
}

func (x *ScheduleFailed) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*ScheduleFailed) ProtoMessage() {}

func (x *ScheduleFailed) ProtoReflect() protoreflect.Message {
	mi := &file_pkg_apis_errordetails_v2_errordetails_proto_msgTypes[3]
	if protoimpl.UnsafeEnabled && x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use ScheduleFailed.ProtoReflect.Descriptor instead.
func (*ScheduleFailed) Descriptor() ([]byte, []int) {
	return file_pkg_apis_errordetails_v2_errordetails_proto_rawDescGZIP(), []int{3}
}

func (x *ScheduleFailed) GetDescription() string {
	if x != nil {
		return x.Description
	}
	return ""
}

var File_pkg_apis_errordetails_v2_errordetails_proto protoreflect.FileDescriptor

var file_pkg_apis_errordetails_v2_errordetails_proto_rawDesc = []byte{
	0x0a, 0x2b, 0x70, 0x6b, 0x67, 0x2f, 0x61, 0x70, 0x69, 0x73, 0x2f, 0x65, 0x72, 0x72, 0x6f, 0x72,
	0x64, 0x65, 0x74, 0x61, 0x69, 0x6c, 0x73, 0x2f, 0x76, 0x32, 0x2f, 0x65, 0x72, 0x72, 0x6f, 0x72,
	0x64, 0x65, 0x74, 0x61, 0x69, 0x6c, 0x73, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x12, 0x0c, 0x65,
	0x72, 0x72, 0x6f, 0x72, 0x64, 0x65, 0x74, 0x61, 0x69, 0x6c, 0x73, 0x1a, 0x17, 0x76, 0x61, 0x6c,
	0x69, 0x64, 0x61, 0x74, 0x65, 0x2f, 0x76, 0x61, 0x6c, 0x69, 0x64, 0x61, 0x74, 0x65, 0x2e, 0x70,
	0x72, 0x6f, 0x74, 0x6f, 0x1a, 0x1f, 0x70, 0x6b, 0x67, 0x2f, 0x61, 0x70, 0x69, 0x73, 0x2f, 0x63,
	0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x2f, 0x76, 0x32, 0x2f, 0x63, 0x6f, 0x6d, 0x6d, 0x6f, 0x6e, 0x2e,
	0x70, 0x72, 0x6f, 0x74, 0x6f, 0x22, 0x95, 0x01, 0x0a, 0x1e, 0x50, 0x65, 0x65, 0x72, 0x44, 0x6f,
	0x77, 0x6e, 0x6c, 0x6f, 0x61, 0x64, 0x42, 0x61, 0x63, 0x6b, 0x54, 0x6f, 0x53, 0x6f, 0x75, 0x72,
	0x63, 0x65, 0x46, 0x61, 0x69, 0x6c, 0x65, 0x64, 0x12, 0x1c, 0x0a, 0x09, 0x74, 0x65, 0x6d, 0x70,
	0x6f, 0x72, 0x61, 0x72, 0x79, 0x18, 0x01, 0x20, 0x01, 0x28, 0x08, 0x52, 0x09, 0x74, 0x65, 0x6d,
	0x70, 0x6f, 0x72, 0x61, 0x72, 0x79, 0x12, 0x33, 0x0a, 0x08, 0x6d, 0x65, 0x74, 0x61, 0x64, 0x61,
	0x74, 0x61, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x17, 0x2e, 0x63, 0x6f, 0x6d, 0x6d, 0x6f,
	0x6e, 0x2e, 0x45, 0x78, 0x74, 0x65, 0x6e, 0x64, 0x41, 0x74, 0x74, 0x72, 0x69, 0x62, 0x75, 0x74,
	0x65, 0x52, 0x08, 0x6d, 0x65, 0x74, 0x61, 0x64, 0x61, 0x74, 0x61, 0x12, 0x20, 0x0a, 0x0b, 0x64,
	0x65, 0x73, 0x63, 0x72, 0x69, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x18, 0x03, 0x20, 0x01, 0x28, 0x09,
	0x52, 0x0b, 0x64, 0x65, 0x73, 0x63, 0x72, 0x69, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x22, 0x7b, 0x0a,
	0x13, 0x50, 0x69, 0x65, 0x63, 0x65, 0x44, 0x6f, 0x77, 0x6e, 0x6c, 0x6f, 0x61, 0x64, 0x46, 0x61,
	0x69, 0x6c, 0x65, 0x64, 0x12, 0x1c, 0x0a, 0x09, 0x74, 0x65, 0x6d, 0x70, 0x6f, 0x72, 0x61, 0x72,
	0x79, 0x18, 0x01, 0x20, 0x01, 0x28, 0x08, 0x52, 0x09, 0x74, 0x65, 0x6d, 0x70, 0x6f, 0x72, 0x61,
	0x72, 0x79, 0x12, 0x24, 0x0a, 0x09, 0x70, 0x61, 0x72, 0x65, 0x6e, 0x74, 0x5f, 0x69, 0x64, 0x18,
	0x02, 0x20, 0x01, 0x28, 0x09, 0x42, 0x07, 0xfa, 0x42, 0x04, 0x72, 0x02, 0x10, 0x01, 0x52, 0x08,
	0x70, 0x61, 0x72, 0x65, 0x6e, 0x74, 0x49, 0x64, 0x12, 0x20, 0x0a, 0x0b, 0x64, 0x65, 0x73, 0x63,
	0x72, 0x69, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x18, 0x03, 0x20, 0x01, 0x28, 0x09, 0x52, 0x0b, 0x64,
	0x65, 0x73, 0x63, 0x72, 0x69, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x22, 0x7b, 0x0a, 0x13, 0x50, 0x69,
	0x65, 0x63, 0x65, 0x49, 0x6e, 0x66, 0x6f, 0x53, 0x79, 0x6e, 0x63, 0x46, 0x61, 0x69, 0x6c, 0x65,
	0x64, 0x12, 0x1c, 0x0a, 0x09, 0x74, 0x65, 0x6d, 0x70, 0x6f, 0x72, 0x61, 0x72, 0x79, 0x18, 0x01,
	0x20, 0x01, 0x28, 0x08, 0x52, 0x09, 0x74, 0x65, 0x6d, 0x70, 0x6f, 0x72, 0x61, 0x72, 0x79, 0x12,
	0x24, 0x0a, 0x09, 0x70, 0x61, 0x72, 0x65, 0x6e, 0x74, 0x5f, 0x69, 0x64, 0x18, 0x02, 0x20, 0x01,
	0x28, 0x09, 0x42, 0x07, 0xfa, 0x42, 0x04, 0x72, 0x02, 0x10, 0x01, 0x52, 0x08, 0x70, 0x61, 0x72,
	0x65, 0x6e, 0x74, 0x49, 0x64, 0x12, 0x20, 0x0a, 0x0b, 0x64, 0x65, 0x73, 0x63, 0x72, 0x69, 0x70,
	0x74, 0x69, 0x6f, 0x6e, 0x18, 0x03, 0x20, 0x01, 0x28, 0x09, 0x52, 0x0b, 0x64, 0x65, 0x73, 0x63,
	0x72, 0x69, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x22, 0x32, 0x0a, 0x0e, 0x53, 0x63, 0x68, 0x65, 0x64,
	0x75, 0x6c, 0x65, 0x46, 0x61, 0x69, 0x6c, 0x65, 0x64, 0x12, 0x20, 0x0a, 0x0b, 0x64, 0x65, 0x73,
	0x63, 0x72, 0x69, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52, 0x0b,
	0x64, 0x65, 0x73, 0x63, 0x72, 0x69, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x42, 0x25, 0x5a, 0x23, 0x64,
	0x37, 0x79, 0x2e, 0x69, 0x6f, 0x2f, 0x61, 0x70, 0x69, 0x2f, 0x70, 0x6b, 0x67, 0x2f, 0x61, 0x70,
	0x69, 0x73, 0x2f, 0x65, 0x72, 0x72, 0x6f, 0x72, 0x64, 0x65, 0x74, 0x61, 0x69, 0x6c, 0x73, 0x2f,
	0x76, 0x32, 0x62, 0x06, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x33,
}

var (
	file_pkg_apis_errordetails_v2_errordetails_proto_rawDescOnce sync.Once
	file_pkg_apis_errordetails_v2_errordetails_proto_rawDescData = file_pkg_apis_errordetails_v2_errordetails_proto_rawDesc
)

func file_pkg_apis_errordetails_v2_errordetails_proto_rawDescGZIP() []byte {
	file_pkg_apis_errordetails_v2_errordetails_proto_rawDescOnce.Do(func() {
		file_pkg_apis_errordetails_v2_errordetails_proto_rawDescData = protoimpl.X.CompressGZIP(file_pkg_apis_errordetails_v2_errordetails_proto_rawDescData)
	})
	return file_pkg_apis_errordetails_v2_errordetails_proto_rawDescData
}

var file_pkg_apis_errordetails_v2_errordetails_proto_msgTypes = make([]protoimpl.MessageInfo, 4)
var file_pkg_apis_errordetails_v2_errordetails_proto_goTypes = []interface{}{
	(*PeerDownloadBackToSourceFailed)(nil), // 0: errordetails.PeerDownloadBackToSourceFailed
	(*PieceDownloadFailed)(nil),            // 1: errordetails.PieceDownloadFailed
	(*PieceInfoSyncFailed)(nil),            // 2: errordetails.PieceInfoSyncFailed
	(*ScheduleFailed)(nil),                 // 3: errordetails.ScheduleFailed
	(*v2.ExtendAttribute)(nil),             // 4: common.ExtendAttribute
}
var file_pkg_apis_errordetails_v2_errordetails_proto_depIdxs = []int32{
	4, // 0: errordetails.PeerDownloadBackToSourceFailed.metadata:type_name -> common.ExtendAttribute
	1, // [1:1] is the sub-list for method output_type
	1, // [1:1] is the sub-list for method input_type
	1, // [1:1] is the sub-list for extension type_name
	1, // [1:1] is the sub-list for extension extendee
	0, // [0:1] is the sub-list for field type_name
}

func init() { file_pkg_apis_errordetails_v2_errordetails_proto_init() }
func file_pkg_apis_errordetails_v2_errordetails_proto_init() {
	if File_pkg_apis_errordetails_v2_errordetails_proto != nil {
		return
	}
	if !protoimpl.UnsafeEnabled {
		file_pkg_apis_errordetails_v2_errordetails_proto_msgTypes[0].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*PeerDownloadBackToSourceFailed); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
		file_pkg_apis_errordetails_v2_errordetails_proto_msgTypes[1].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*PieceDownloadFailed); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
		file_pkg_apis_errordetails_v2_errordetails_proto_msgTypes[2].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*PieceInfoSyncFailed); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
		file_pkg_apis_errordetails_v2_errordetails_proto_msgTypes[3].Exporter = func(v interface{}, i int) interface{} {
			switch v := v.(*ScheduleFailed); i {
			case 0:
				return &v.state
			case 1:
				return &v.sizeCache
			case 2:
				return &v.unknownFields
			default:
				return nil
			}
		}
	}
	type x struct{}
	out := protoimpl.TypeBuilder{
		File: protoimpl.DescBuilder{
			GoPackagePath: reflect.TypeOf(x{}).PkgPath(),
			RawDescriptor: file_pkg_apis_errordetails_v2_errordetails_proto_rawDesc,
			NumEnums:      0,
			NumMessages:   4,
			NumExtensions: 0,
			NumServices:   0,
		},
		GoTypes:           file_pkg_apis_errordetails_v2_errordetails_proto_goTypes,
		DependencyIndexes: file_pkg_apis_errordetails_v2_errordetails_proto_depIdxs,
		MessageInfos:      file_pkg_apis_errordetails_v2_errordetails_proto_msgTypes,
	}.Build()
	File_pkg_apis_errordetails_v2_errordetails_proto = out.File
	file_pkg_apis_errordetails_v2_errordetails_proto_rawDesc = nil
	file_pkg_apis_errordetails_v2_errordetails_proto_goTypes = nil
	file_pkg_apis_errordetails_v2_errordetails_proto_depIdxs = nil
}
